POST Create a Transaction Asynchronously
POST /disbursement/v1/transactions/async
Development Guide
The 'Create a Transaction Asynchronously' endpoint accepts all data required for the transaction and will respond synchronously with a transactionId resource. This allows transaction to be processed with high throughput.
MoneyGram will asynchronously validate the data for compliance purposes and process the transaction. Once MoneyGram has processed the transaction, the application can poll the Retrieve a Lite Transaction Status or listen to the Webhook to asynchronously retrieve the transaction referenceNumber and quote information.
1. Prepare headers & authentication:
The application must call the Create a transaction with Auto-Commit Async' endpoint with a POST HTTP method, providing the OAuth access_token in the header and all other required header values.
Note: MoneyGram uses the OAuth 2.0 framework. The application must use their OAuth client credentials to generate an
access_tokenby calling the Get access token endpoint. The token is valid for 1 hour and must be passed as a header value in all subsequent API HTTP calls. Learn More
2. Provide request body: "Transact by send amount" OR "Transact by receive amount":
The application must use the oneOf Keyword to update a transaction by send or receive amount. At this point the application also has the option to re-quote the transactionId by entering a different sendAmount.value, serviceOptionCode or destinationCountry:
- Transact by send amount: The application must provide the following required fields in the request body:
targetAudience,agentPartnerId,destinationCountryCode,serviceOptionCode,sendAmount.value,sendAmount.currencyCode, andreceiveCurrencyCode.
OR
- Transact by receive amount: The application must provide the following required fields in the request body:
targetAudience,agentPartnerId,destinationCountryCode,serviceOptionCode,receiveAmount.value,receiveAmount.currencyCode, andsendCurrencyCode
Note:
- The Update API uses ISO Standards for country and currency values. MoneyGram provides Reference Data APIs which can be queried to understand the supported values and associated metadata.
- Additional data collection may be required based on the
sendAmountanddestinationCountryCode.
.
3. Provide the sender in the request body:
sender in the request body:he the application must use the oneOf Keyword to provide the sender information. The application can use three oneOf options to provide sender information:
- Option 1 -
businessProfileId: For partner's using a MoneyGram business profile, the applications can provide the MoneyGrambusinessProfileId. To use this option, the application must first call the Create Business Profile API to create a business profile at MoneyGram and generate abusinessProfileId. ThebusinessProfileIdis a unique identifier of the business and will last the life time of the account.
OR
- Option 2 -
partnerBusinessProfileId: For partner's using their own business profile, the application can pass their unique profile identifier in thepartnerBusinessProfileId. The application must first call the Create Business Profile API to create a business profile at MoneyGram and pass their uniquepartnerBusinessProfileId. MoneyGram will associate the partner's identifier with our business profile creation.
OR
- Option 3 -
business: For partner's using an account-free model, the application can pass all the business sender fields in the business object.
.
.
4. Provide the required Beneficiary fields in the request body:
The application must use the oneOf Keyword to provide the beneficiary. The application can only use one oneOf options to provide beneficiary information in this application when performing a B2C transaction:
- Option 1 -
consumer: For partner's performing a Business-to-Consumer (B2C) transactions, the application can provideconsumerdetails as the beneficiary.
.
5. Provide thetransactionInformation in the request body (optional):
transactionInformation in the request body (optional):Any required transaction information can be provided in the transactionInformation object.
6. Make a request and handle response:
The application must call the 'Create a transaction with auto-commit async' endpoint with a POST HTTP method. The application must build to handle the following response scenarios:
- Success | Parse the Response | 200 OK HTTP Status
When the 'Create Transaction Asynchronously' endpoint responds with a 200 HTTP Status the respond with atransactionId. MoneyGram will process the transaction Asynchronously.
- Failed | Handle the Error | 400 Bad Request HTTP Status
When the 'Create a transaction with auto-commit async' endpoint responds with 400 Bad Request HTTP Status the application cannot proceed. Specific error code/s will be returned with an array of offending fields. The application will need to resolve these errors and resubmit the transaction. The application can make repeated attempts on the 'Create a transaction with auto-commit' endpoint until validation is successful.
Note: In some scenarios, enhanced due diligence needs to be undertaken on the consumer. Specific error code/s will be returned and an array of offending fields. The fields/values must to be provided and resubmitted on the Update API for further checks.
.
8. You're Done! Listen to the Webhook or use the 'Retrieve a Lite Transaction Status' to get the referenceNumber asynchronously:
referenceNumber asynchronously:The application must listen to the webhook that will respond with the referenceNumber in a notification asynchronously. The application can also poll the 'Retrieve a Lite Transaction Status' API to get the referenceNumber asynchronously.
Code Examples
const axios = require('axios');
const { v4: uuidv4 } = require('uuid');
const updateTransaction = async () => {
// Step 1: Read configuration values with upmost security
const token = "your_access_token_from_oauth_response"
// For production - api.moneygram.com & For test - sandboxapi.moneygram.com
const host = "sandboxapi.moneygram.com";
const transactionId = "current_transaction_id";
const url = 'https://' + host + '/disbursement/v1/transactions/async';
// Step 2: Create the PUT request headers & body
const headers = {
'Content-Type': 'application/json',
'X-MG-ClientRequestId': uuidv4(), // New UUID for each request tracing
'Authorization': 'Bearer ' + token,
};
const request = {
agentPartnerId: "your_partner_id",
targetAudience: "AGENT_FACING",
userLanguage: "en-US",
destinationCountryCode: "USA",
destinationCountrySubdivisionCode: "US-MN",
serviceOptionCode: "WILL_CALL",
sendAmount: {
value: 500,
currencyCode: "USD"
},
receiveCurrencyCode: "USD",
sender: {
business: {
businessName: "ACME",
legalEntityName: "ACME",
businessRegistrationNumber: "ACME2024",
businessCountryOfRegistration: "USA",
address: {
line1: "100 Main St",
city: "Springfield",
countryCode: "USA"
}
}
},
beneficiary: {
consumer: {
name: {
firstName: "Sally",
lastName: "Smith"
},
address: {
line1: "200 Main St",
city: "Springfield",
countryCode: "USA"
}
}
}
}
try {
// Step 3: Send the request and obtain the response
axios.put(url, request, { headers })
.then(function (response) {
// Step 4: Parse the success response and process further
// Verify readyForCommit is true, if yes, transaction is ready to commit
console.log(JSON.stringify(response.data, null, 2))
})
.catch(function (error) {
// Step 5: Parse the error response and handle the errors
if (error.response) {
console.log('Response status:', error.response.status);
console.log('Response body:', error.response.data);
} else {
// TODO: handle generic errors
console.error('Error:', error.message);
}
});
} catch (error) {
// TODO: handle exception
console.error('Error:', error.message);
}
};
updateTransaction();import requests
import uuid
import json
def update_transaction():
# Step 1: Read configuration values with upmost security
token = "your_access_token_from_oauth_response"
# For production - api.moneygram.com & For test - sandboxapi.moneygram.com
host = "sandboxapi.moneygram.com";
transactionId = "current_transaction_id";
url = 'https://' + host + '/disbursement/v1/transactions/async';
# Step 2: Create the PUT request headers & body
headers = {
'Content-Type': 'application/json',
'X-MG-ClientRequestId': str(uuid.uuid4()), # New UUID for each request tracing
'Authorization': 'Bearer ' + token,
}
request = {
'agentPartnerId': 'your_partner_id',
'targetAudience': 'AGENT_FACING',
'userLanguage': 'en-US',
'destinationCountryCode': 'USA',
'destinationCountrySubdivisionCode': 'US-MN',
'serviceOptionCode': 'WILL_CALL',
'sendAmount': {
'currencyCode': 'USD',
'value': 500
},
'receiveCurrencyCode': 'USD',
'sender': {
'business': {
'businessName': "ACME",
'legalEntityName': "ACME",
'businessRegistrationNumber': "ACME2024",
'businessCountryOfRegistration': "USA",
'address': {
'line1': "100 Main St",
'city': "Springfield",
'countryCode': "USA"
}
}
},
'beneficiary': {
'consumer': {
'name': {
'firstName': "Sally",
'lastName': "Smith"
},
'address': {
'line1': "200 Main St",
'city': "Springfield",
'countryCode': "USA"
}
}
}
}
try:
# Step 3: Send the request and obtain the response
response = requests.put(url, json=request, headers=headers)
# Step 4: Parse the success response and process further
if response.status_code == 200:
parsed_response = json.dumps(json.loads(response.text), indent=2)
print(parsed_response)
else:
# Step 5: Parse the error response and handle the errors
print("Request failed with status code:", response.status_code)
print(json.dumps(json.loads(response.text), indent=2))
except requests.exceptions.RequestException as e:
# Print any error that occurred during the request
# TODO: handle exception
print("An error occurred:", e)
update_transaction()package disbursement;
import javax.json.Json;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;
import javax.json.JsonWriter;
import java.io.StringWriter;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.UUID;
public class UpdateTransaction {
public static void main(String[] args) {
// Step 1: Read configuration values with upmost security
String token = "your_access_token_from_oauth_response";
// For production - api.moneygram.com & For test - sandboxapi.moneygram.com
String host = "sandboxapi.moneygram.com";
String transactionId = "current_transaction_id";
String tokenEndpoint = "https://" + host + "/disbursement/v1/transactions/async"
// Step 2: Create the PUT request headers & body
// Create a JSON object
JsonObjectBuilder sendAmountBuilder = Json.createObjectBuilder()
.add("value", 500)
.add("currencyCode", "USD");
JsonObjectBuilder senderBuilder = Json.createObjectBuilder()
.add("sender", "business")
.add("businessName", "ACME")
.add("legalEntityName", "ACME")
.add("businessRegistrationNumber", "ACME2024")
.add("businessCountryOfRegistration", "USA");
JsonObjectBuilder beneficiaryBuilder = Json.createObjectBuilder()
.add("beneficiary", "consumer")
.add("name", Json.createObjectBuilder().add("firstName", "firstName").add("lastName", "lastName"))
.add("address",Json.createObjectBuilder().add("line1", "line1").add("city", "city").add("countryCode", "countryCode"));
JsonObjectBuilder requestBuilder = Json.createObjectBuilder()
.add("agentPartnerId", "your_partner_id")
.add("targetAudience", "AGENT_FACING")
.add("userLanguage", "en-US")
.add("destinationCountryCode", "USA")
.add("destinationCountrySubdivisionCode", "US-MN")
.add("serviceOptionCode", "WILL_CALL")
.add("sendAmount", sendAmountBuilder)
.add("receiveCurrencyCode", "USD")
.add("sender", senderInitiator)
.add("beneficiary", beneficiaryBuilder);
JsonObject jsonObject = requestBuilder.build();
// Create a StringWriter to write the JSON string
StringWriter stringWriter = new StringWriter();
try (JsonWriter jsonWriter = Json.createWriter(stringWriter)) {
jsonWriter.writeObject(jsonObject);
}
// Get the JSON string from the StringWriter
String jsonString = stringWriter.toString();
HttpClient httpClient = HttpClient.newHttpClient();
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create(tokenEndpoint))
.PUT(HttpRequest.BodyPublishers.ofString(jsonString))
.setHeader("Authorization", "Bearer " + token)
.setHeader("X-MG-ClientRequestId", String.valueOf(UUID.randomUUID()))
.build();
try {
// Step 3: Send the request and obtain the response
HttpResponse<String> response = httpClient.send(request, HttpResponse.BodyHandlers.ofString());
// Retrieve the status code and body from the response
int statusCode = response.statusCode();
// Step 4: Parse the success response and process further
if (statusCode == 200) {
String responseBody = response.body();
System.out.println(responseBody);
} else {
// Step 5: Parse the error response and handle the errors
String responseBody = response.body();
System.out.println(responseBody);
}
} catch (Exception e) {
e.printStackTrace();
// TODO: handle exception
}
}
}Support APIs
To make your development easier, MoneyGram has provided a Reference Data APIs Module that can be queried to provide a list of supported fields, values and associated meta-data to use in your integration.
| Name | HTTP Method | Endpoints | Description |
|---|---|---|---|
| Retrieve Countries | GET | /reference-data/v1/Country | Retrieves supported values and metadata for countries |
| Retrieve Countries ISO3 | GET | /reference-data/v1 /countries/{iso3Code} | Retrieves supported values and metadata for countries by ISO 3 Code |
| Retrieve Currencies | GET | /reference-data/v1/currencies | Retrieves supported values and metadata for currencies |
| Retrieve Enumerations | GET | /reference-data/v1/enumerations | Retrieves enumerated values for fields |
| Retrieve Identification Documents | GET | /reference-data/v1/identification-Documents | Retrieves required fields for identification documents |
| Retrieve Service Options | GET | /reference-data/v1/payout-options | Retrieves supported values and metadata for Service Options |
API Structure
Header Parameters
| Name | Type | Required /Optional | Description |
|---|---|---|---|
X-MG-ClientRequestId | String | Required | Client Request ID that can be passed by the client application. Client request ID must be unique within a single session for unique requests. This attribute can be used for ensuring idempotent request processing for some APIs. MoneyGram recommends using a UUID for the value of this field. |
X-MG-ConsumerIPAddress | String | Optional | IP Address of the system initiating the session |
Request Body Parameters
| Body Parameter | Description |
|---|---|
| transactBySendAmountAsyncRequest | Transact by send amount |
| transactByReceiveAmountAsyncRequest | Transact by receive amount |
Request Body Fields
Partner Information, Service Option, Destination, Amounts
| Field | Type | Description |
|---|---|---|
targetAudience | String (Required) | Tailors MoneyGram’s error messages and field metadata to an in-store, digital or crypto customer. (Enumerated value) NOTE: For a full list of accepted target audience values. See the TARGET_AUDIENCE enumeration from the Reference Data Enumerations endpoint |
agentPartnerId | String (Required) Max length: 8 | Unique identifier for the agent or partner |
userLanguage | String (Optional) Max length: 6 | Language used by the user/operator |
partnerTransactionId | String (Optional) | Partners Unique identifier for the transaction resource. |
destinationCountryCode | String (Required) Max Length: 3 | Transaction Destination Country (ISO alpha-3 code) NOTE: For a full list of accepted destination Countries and supported destinationCountrySubdivisionCode see Reference Data API Module: Retrieve Countries ISO3 endpoint |
destinationCountrySubdivisionCode | String (Optional) Max length: 6 | Destination state/province is conditionally required when transacting to certain destination countries. (ISO alpha-3 code) NOTE: For a full list of accepted destination countries and supported destination country subdivision codes see Reference Data API Module: Retrieve Countries ISO3 endpoint |
serviceOptionCode | String (Required) Max length: 21 | Unique category code to identify the transaction method NOTE: For a full list of accepted service option codes per destination country see the Reference Data API Module: service-options endpoint |
serviceOptionRoutingCode | String (Optional) Max length: 21 | Unique identifier of the individual banking, wallet, or card provider for the service option. NOTE: For a full list of accepted service option codes per destination country see the Reference Data API Module: service-options endpoint |
sendAmount.value | Number (Required) Min length: 0 Max length: 14 Max Decimal Value: 3 | Transaction amount and currency excluding fees and exchange rate. NOTE: For Crypto partners this is the fiat currency for the BUY/Sell or Ramp-on/Ramp-off For a full list of transaction currency codes see the API Reference Data Module: currencies endpoint |
sendAmount.currencyCode | String (Required) Max length: 3 | Transaction send currency code for a transactBySendAmountRequest |
receiveCurrencyCode | String (Required) Max length: 3 | Receive Currency is needed when transacting to a destination country that supports more than one currency for a transactBySendAmountRequest (ISO alpha-3 code) |
receiveAmount.value | Number (Required) Min length: 0 Max length: 14 Max Decimal Value: 3 | Transaction receive amount excluding fees and exchange rate for a transactByReceiveAmountRequest Transaction Currency (ISO alpha-3 code) |
receiveAmount.currencyCode | String (Required) Max length: 3 | Transaction receive currency code for a transactByReceiveAmountRequest (ISO alpha-3 code) |
sendCurrencyCode | String (Optional) Max length: 3 | Receive currency is needed when transacting to a destination country that supports more than one currency for a transactByReceiveAmount Request (ISO alpha-3 code) |
promotionCodes | String (Optional) Max length: 20 | Unique code to apply a promotional discount |
Sender oneOf Options:
The sender target="_blank""> "oneOf" options allow the application to collect the business sender information for a transaction using one of three options businessProfileId, partnerBusinessProfileId, or business
Option 1: sender.businessProfileId
sender.businessProfileId| Field | Type | Required /Optional | Description |
|---|---|---|---|
sender.businessProfileId | String | Optional | A unique MoneyGram identifier for the business. |
Option 2: sender.partnerBusinessProfileId
sender.partnerBusinessProfileId| Field | Type | Required /Optional | Description |
|---|---|---|---|
sender.partnerBusinessProfileId | String | Optional | The partner’s business profileId that will be passed from the partner and mapped to the MoneyGram business profile Id. |
Option 3: sender.business
sender.business| Field | Type | Required /Optional | Description |
|---|---|---|---|
sender.business.partnerBusinessProfileId | String | Optional | Partners business profileId this will be passed from the partner and mapped to the MoneyGram profileId. |
sender.business.businessName | String Min Length: 1 Max Length: 100 | Required | Name of the business |
sender.business.legalEntityName | String Min Length: 1 Max Length: 100 | Required | The legal name of the business |
sender.business.businessType | String | Optional | Type of business (Enumerated Values) |
sender.business.businessRegistrationNumber | String | Required | Business registration number |
sender.business.businessIssueDate | String | Optional | Date of business formation |
sender.business.businessCountryOfRegistration | String Min Length: 1 Max Length: 20 | Required | Business’s country of registration |
sender.business.address.line1 | String Min Length: 5 Max Length: 30 | Required | Residence address line 1 |
sender.business.address.line2 | String Min Length: 0 Max Length: 30 | Optional | Residence address line 2 (if applicable) |
sender.business.address.line3 | String Min Length: 0 Max Length: 30 | Optional | Residence address line 3 (if applicable) |
sender.business.address.city | String Min Length: 1 Max Length: 20 | Required | Business City |
sender.business.address.countryCode | String Length: 3 | Required | Country of residence (ISO Alpha-3 Code) |
sender.business.address.countrySubdivisionCode | String Length: 6 | Optional | State/province of business |
sender.business.address.postalCode | String Min Length: 2 Max Length: 6 | Optional | Postal code/ZIP of business |
sender.business.contactDetails.email | String Min Length: 1 Max Length: 255 | Optional | Email address |
sender.business.contactDetails.phone.number | String Min Length: 5 Max Length: 14 | Optional | Business phone number |
sender.business.contactDetails.phone.countryDialCode | String Min Length: 1 Max Length: 3 | Optional | Country calling code Note: For country calling code see Reference Data API Module /countries endpoint phoneDialCodes |
Beneficiary oneOf Options:
The beneficiary \"oneOf\" options allow the application to collect the beneficiary information for a transaction using one of two different options business, or consumer.
Option 1: beneficiary.consumer
beneficiary.consumer| Field | Type | Required /Optional | Description |
|---|---|---|---|
beneficiary.consumer.name.firstName | String Min length: 1 Max length: 20 | Required | First Name |
beneficiary.consumer.name.middleName | String Min length: 1 Max length: 20 | Optional | Middle Name (if applicable) |
beneficiary.consumer.name.lastName | String Min length: 1 Max length: 30 | Required | Last Name |
beneficiary.consumer.name.secondLastName | String Min length: 1 Max length: 30 | Optional | Second Last Name |
beneficiary.consumer.address.line1 | String Min length: 5 Max length: 30 | Optional | Residence address line 1 |
beneficiary.consumer.address.line2 | String Min length: 0 Max length: 30 | Optional | Residence address line 2 (if applicable) |
beneficiary.consumer.address.line3 | String Min length: 0 Max length: 30 | Optional | Residence address line 3 (if applicable) |
beneficiary.consumer.address.city | String Min length: 0 Max length: 20 | Required | City of residence |
beneficiary.consumer.address.countrySubdivisionCode | String Max Length: 6 | Optional | State/province of residence. NOTE: For a full list of accepted countries and supported destination country subdivision codes see Reference Data API Module: Retrieve Countries ISO3 endpoint |
beneficiary.consumer.address.countryCode | String Max length: 3 | Required | Country of residence. NOTE: For a full list of accepted countries and supported destination country subdivision codes see Reference Data API Module: Retrieve Countries ISO3 endpoint |
beneficiary.consumer.address.postalCode | String Min length: 2 Max length: 6 | Optional | Postal code/ZIP of residence |
beneficiary.consumer.mobilePhone.number | String Min length: 5 Max length: 14 | Optional | Phone number |
beneficiary.consumer.mobilePhone.countryDialCode | String Min length: 1 Max length: 5 | Optional | Country calling code (ISO alpha-3 code) |
Attachments
| Field | Type | Required /Optional | Description |
|---|---|---|---|
attachments.name | String Min Length: 1 Max Length: 100 | Optional | Name of the attachment |
attachments.type | String | Optional | Type of attachment (Enumerated Values)
|
attachments.typeCategory | String | Optional | Category of the attachment (Enumerated Values)
|
attachments.file | String | Optional | The file to be uploaded |
Additional Details
| Field | Type | Required /Optional | Description |
|---|---|---|---|
additionalDetails | Dynamic | Optional | Dynamic field key/values for the transaction |
Response Fields
| Field | Type | Required /Optional | Description |
|---|---|---|---|
transactionId | String Max length: 36 | Optional | Unique identifiers for the transaction resource |
partnerTransactionId | String | Optional | Partners Unique identifier for the transaction resource |
